UNIT Audio;
(* Audio subsystem. *)

INTERFACE

  USES
    al5audio;

  VAR
  (* Audio samples.  Use them as if they were read-only. *)
    SampleShot: ALLEGRO_SAMPLEptr;
    SampleExplode: ARRAY [0..1] OF ALLEGRO_SAMPLEptr;

(* Initializes the audio subsystem and load samples. *)
  PROCEDURE Initialize;
(* Releases resources. *)
  PROCEDURE Deinitialize;

IMPLEMENTATION

  USES
    General,
    al5acodec;

(* Initializes. *)
  PROCEDURE Initialize;
  BEGIN
    MustInit (al_install_audio, 'audio');
    MustInit (al_init_acodec_addon, 'audio codecs');
    MustInit (al_reserve_samples (128), 'reserve samples');

    SampleShot := al_load_sample ('shot.flac');
    MustInit (SampleShot <> NIL, 'shot sample');

    SampleExplode[0] := al_load_sample ('explode1.flac');
    MustInit (SampleExplode[0] <> NIL, 'explode[0] sample');
    SampleExplode[1] := al_load_sample ('explode2.flac');
    MustInit (SampleExplode[1] <> NIL, 'explode[1] sample')
  END;



  PROCEDURE Deinitialize;
  BEGIN
    al_destroy_sample (SampleShot);
    al_destroy_sample (SampleExplode[0]);
    al_destroy_sample (SampleExplode[1])
  END;

END.
