UNIT General;
(* Defines general stuff. *)

INTERFACE

  VAR
  (* Frame count. *)
    Frames: LONGINT;

(* Checks if initialized.  Sows error message and HALTs if it doesn't. *)
  PROCEDURE MustInit (aTest: BOOLEAN; CONST aDescription: STRING);
(* Returns a random integer from 'Lower' to 'Higher'. *)
  FUNCTION IntegerBetween (CONST Lower, Higher: LONGINT): LONGINT;
  FUNCTION FloatBetween (CONST Lower, Higher: REAL): REAL;

IMPLEMENTATION

(* Checks if initialized.  Sows error message and HALTs if it doesn't. *)
  PROCEDURE MustInit (aTest: BOOLEAN; CONST aDescription: STRING);
  BEGIN
    IF NOT aTest THEN
    BEGIN
      WriteLn ('[Error] Couldn''t initialize system: ', aDescription);
      WriteLn ('Press [Enter] to close...');
      ReadLn;  { Waits for user pressing [Intro]. }
      Halt (1) { Returns error state. }
    END
  END;



(* Random generator. *)
  FUNCTION IntegerBetween (CONST Lower, Higher: LONGINT): LONGINT;
  BEGIN
    IntegerBetween := Lower + Random (Higher - Lower)
  END;

  FUNCTION FloatBetween (CONST Lower, Higher: REAL): REAL;
  BEGIN
    FloatBetween :=
      IntegerBetween (TRUNC (Lower * 10000), TRUNC (Higher * 10000)) / 10000
  END;

END.
