UNIT Keyboard;
(* Implements keyboard. *)

INTERFACE

  USES
    allegro5;

  CONST
  (* Key statuses. *)
    KEY_SEEN     = 1;
    KEY_RELEASED = 2;

  VAR
    Key: ARRAY [0..ALLEGRO_KEY_MAX] OF BYTE;

(* Initializes keyboard. *)
  PROCEDURE Initialize;
(* Handles keyboard events. *)
  PROCEDURE HandleEvent (CONST aEvent: ALLEGRO_EVENT);

IMPLEMENTATION

  USES
    General;

(* Initialization. *)
  PROCEDURE Initialize;
  VAR
    Ndx: INTEGER;
  BEGIN
    MustInit (al_install_keyboard, 'keyboard');
    FOR Ndx := LOW (Key) TO HIGH (Key) DO Key[Ndx] := 0
  END;



(* Handles keyboard events. *)
  PROCEDURE HandleEvent (CONST aEvent: ALLEGRO_EVENT);
  VAR
    Ndx: INTEGER;
  BEGIN
    CASE aEvent.ftype OF
    ALLEGRO_EVENT_TIMER:
      FOR Ndx := LOW (Key) TO HIGH (Key) DO Key[Ndx] := Key[Ndx] AND KEY_SEEN;

    ALLEGRO_EVENT_KEY_DOWN:
      Key[aEvent.keyboard.keycode] := KEY_SEEN OR KEY_RELEASED;
    ALLEGRO_EVENT_KEY_UP:
      Key[aEvent.keyboard.keycode] :=
        Key[aEvent.keyboard.keycode] AND KEY_RELEASED;
    END
  END;

END.
