UNIT Starfield;
(* Implements a starfield. *)

INTERFACE

(* Initializes the starfield. *)
  PROCEDURE Initialize;
(* Updates starfield. *)
  PROCEDURE Update;
(* Draws starfield. *)
  PROCEDURE Draw;

IMPLEMENTATION

  USES
    Display, General,
    allegro5, al5primitives;

  CONST
    NUM_STARS = (BUFFER_W DIV 2) - 1;

  TYPE
  (* Star definition. *)
    TStar = RECORD
      y, Speed: REAL;
    END;

  VAR
    fStar: ARRAY [1..NUM_STARS] OF TStar;

(* Initializes the starfield. *)
  PROCEDURE Initialize;
  VAR
    Cnt: INTEGER;
  BEGIN
    FOR Cnt := 1 TO NUM_STARS DO
    BEGIN
      fStar[Cnt].y := FloatBetween (0, BUFFER_H);
      fStar[Cnt].Speed := FloatBetween (0.1, 1)
    END
  END;



(* Updates starfield. *)
  PROCEDURE Update;
  VAR
    Ndx: INTEGER;
  BEGIN
    FOR Ndx := 1 TO NUM_STARS DO
    BEGIN
      fStar[Ndx].y := fStar[Ndx].y + fStar[Ndx].Speed;
      IF fStar[Ndx].y >= BUFFER_H THEN
      BEGIN
        fStar[Ndx].y := 0;
        fStar[Ndx].Speed := FloatBetween (0.1, 1)
      END
    END
  END;



(* Draws starfield. *)
  PROCEDURE Draw;
  VAR
    StarX, Clr: REAL;
    Ndx: INTEGER;
  BEGIN
    StarX := 1.5;
    FOR Ndx := 1 TO NUM_STARS DO
    BEGIN
      Clr := fStar[Ndx].Speed * 0.8;
      al_draw_pixel (StarX, fStar[Ndx].y, al_map_rgb_f (Clr, Clr, Clr));
      StarX := StarX + 2;
    END
  END;

END.
